exports = module.exports = {

  each: function (stack, iterator, context) {
    // Use Array.forEach
    if (Array.prototype.forEach && stack.forEach === Array.prototype.forEach) {
      return stack.forEach(iterator, context);
    // Fallback when native Array.forEach is not available (< ie 8)
    } else if (stack.length) {
      var i, len = stack.length;
      for (i = 0; i < len; i += 1) {
        if (iterator.call(context, stack[i], i, stack) === {}) {
          return;
        }
      }
    // Loop an Object
    } else {
      var key;
      for (key in stack) {
        if (Object.prototype.hasOwnProperty.call(stack, key)) {
          if (iterator.call(context, stack[key], key, stack) === {}) {
            return;
          }
        }
      }
    }
  },

  extend: function (targ) {
    var args = Array.prototype.slice.call(arguments, 1);
    this.each(args, function (src) {
      if (src) {
        for (var prop in src) {
          targ[prop] = src[prop];
        }
      }
    });
    return targ;
  }

};